#include "stdafx.h"
#include <float.h>				// For DBL_MAX.
#include "DynamicDraw.h"		// For FFCanCreateObject.
#include "FoundDoc.h"			// For g_pDoc.
#include "DynamicDrawView.h"	// For g_pView.
#include "UtilCoord.h"			// For mm2lg.etc.
#include "UtilGraph.h"			// For FCEditDraw.
#include "UtilMisc.h"			// For FFSetCapture.etc.
#include "UtilWin.h"			// For FFPostSendMessage.
#include "ObjRect.h"			// For FCObjRect.
#include "ObjPoly.h"			// For FCObjPoly.
#include "LayerManager.h"		// For FDOZ_ON_SELECT.
#include "ZOrder.h"				// For FCZOrder.
#include "LinkManager.h"		// For FCLinkManager.
#include "ToolBasePutCreate.h"	// This header.

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//////////////////////////////////////////////////////////////////////////
// FCToolBasePutCreate _xZkqqHx_iDiNiBfLiDeKiDiLiKnGjAjEiBeC_xHqqkZx_

//----- 05.06.07 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	myGetMolipPos
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iOhHjCoIiCmMjFjEjFgJiCmMiOhHjCoIiCmMiDiCiDiKiDhG_xHqqkZx_ID_xZkqqHx_iCmMiDiCiDiKiDhGiImKjChFiCpAiOoGjDlOiClHiCoJiKnGjAjEiBeC_xHqqkZx_
// *
// * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	mmpt		:_xZkqqHx_iDiCiDiKiDhGiImKjChFiCpAjFnEiClHiBeC_xHqqkZx_
// *			dwData		:_xZkqqHx_iClBiCmMiKnGjAjEjHhAiCmMiDgGiBfLiDfOiCpAiOhHjCoIiBeC_xHqqkZx_
// *			pObj		:_xZkqqHx_iDfOiBfLiDfBiDgCiDgHiCmMjFjEjFgJiCpAiOhHjCoIiBeC_xHqqkZx_
// *			lMolipId	:_xZkqqHx_iDiCiDiKiDhG_xHqqkZx_ID_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
// *			lTerminalIdx:_xZkqqHx_iDiCiDiKiDhGiCmMiDfOiBfLiDhOiDgJiDiLiDeDiDjDiDgGiDgCiDeOiDfIiCpAiOhHjCoIiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_iOoGjDlOiCmFiCkLiClNiPoKiNiHiCmN_xHqqkZx_ TRUE_xZkqqHx_iBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	01.08.21 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//static BOOL myGetMolipPos (	DBLPoint& mmpt, DWORD dwData, const FCObjDynabase* pObj,
//							long lMolipId, long lTerminalIdx)
//{
//	pObj->GetMolipPos(mmpt, lMolipId, lTerminalIdx);
//	return TRUE;
//} // myGetMolipPos.
//----- 05.06.07 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----

//////////////////////////////////////////////////////////////////////////
// FCToolBasePutCreate _xZkqqHx_iDiBiDjDiDgPiKnGjAjEiBeC_xHqqkZx_

//----- 06.12.09 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolBasePutCreate::OnDraw
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iPjBiCkLjClMiClFiCmMiCmGiCkL_xHqqkZx_View_xZkqqHx_iCkJiCoHiOmAiNhDiClDiCoKiCoJiBeC_xHqqkZx_
// *
// * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC		:_xZkqqHx_jFfMiOkGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
// *			pmmrtRgn:_xZkqqHx_iDiKiBfLiDfHiDiHiDjDjEhKjHpBiCpAiOhHjCoIiBeCiOgHiCoNiCmIiCkCiPoKiNiHiCmN_xHqqkZx_NULL_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
// *			lRgnSize:pmmrtRgn_xZkqqHx_iCmMjEhKjHpBiDfEiDeDiDfJiCpAiOhHjCoIiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	00.01.25 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *			00.03.12 Fukushiro M. _xZkqqHx_iPiIjHjNiCpAjCmHiJmBiBeC_xHqqkZx_
// *************************************************************************/
//void FCToolBasePutCreate::OnDraw (CDC* pDC)
//{
//	// FDA_xZkqqHx_iCmMiMlLiNnNiCmMiPpDjBnEiBeC_xHqqkZx_
//	switch (GetCurrentState())
//	{
//	case STATE_PUTTING_TEXT:	// _xZkqqHx_iDgFiDeMiDfIiDgHjAnNjCoIjCiGiBeC_xHqqkZx_
//	  {
//		// _xZkqqHx_iDiKiDhEiDeAiDiMiDjDiDfIjFjEjFgJiCkKiCmIiCkCiCmIiCoHiCmOiBeBiPiIjHjNiClFiCmIiCkCiBeC_xHqqkZx_
//		if (m_pReference == NULL) break;
//		//----- _xZkqqHx_iDiKiDhEiDeAiDiMiDjDiDfIjFjEjFgJiCmMiDhEiDiMiBfLiDiAiCpAjFgAiJoG_xHqqkZx_ -----
//		// _xZkqqHx_iPeDjAlDjApMjFgAiJoGjHhAiDeOiDiJiDfIiCpAiNoMjAkMiBeC_xHqqkZx_
//		FCEditDraw eDraw(pDC, 0);
//		// _xZkqqHx_iDhEiDiMiBfLiDiAjApMiCpAjFgAiJoGiBeC_xHqqkZx_
//		eDraw.RectLine(mm2lg(m_mmptReferenceLT + m_mmptReferenceHSz),
//						mm2lg(m_mmptReferenceHSz.x), mm2lg(m_mmptReferenceHSz.y));
//		break;
//	  }
//	}
//	// Superclass_xZkqqHx_iKnGjAjEiOmAiNhDiBeC_xHqqkZx_
//	BASE_CLASS::OnDraw(pDC);
//} // FCToolBasePutCreate::OnDraw.
//----- 06.12.09 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----

//----- 05.04.24 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
///*************************************************************************
// * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolBasePutCreate::Select
// *
// * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iClBiCmMiDgDiBfLiDiLiCkKjBeJjBpAiClDiCoKiClNiCmGiCkLiBeBiDfCiBfLiDiLiClDiCoKiCoJiBeC_xHqqkZx_
// *
// * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	:_xZkqqHx_jFgAiJoGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
// *
// * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	00.01.25 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
// *************************************************************************/
//void FCToolBasePutCreate::Select (CDC* pDC)
//{
//	// Superclass_xZkqqHx_iKnGjAjEiOmAiNhDiBeC_xHqqkZx_
//	BASE_CLASS::Select(pDC);
//	// _xZkqqHx_iMlLiNnNiCmMiDeKiBfLiDfMiDiLiPoOjFpBiBeCiClBiCoKiCmFiDhNiDeFiDfIiInKjDkOiOjOiCmJiDhNiBfLiDeOjFfMiOkGiClDiCoKiCoJiBeC_xHqqkZx_
//	m_iCursorNew = FDPA_HIT_NOT_MOLIP;
//} // FCToolBasePutCreate::Select.
//----- 05.04.24 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolBasePutCreate::CreateRegisteredObject
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_jFjEjFgJiCmMjEhKjChFiOjOiCmJiBeBiOfBiPmGjFjEjFgJiCpAiMlDiCmJiNoMjAkMiClHiCoJjFjEjFgJiCpAiNoMjAkMiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	vNewObj		:_xZkqqHx_iNoMjAkMiClFiClNjFjEjFgJiCpAjFnEiClHiBeC_xHqqkZx_
 *			mmrtFrame	:vNewObj_xZkqqHx_iCmMiDhEiDiMiBfLiDiAiCpAjFnEiClHiBeC_xHqqkZx_
 *			vLinkRec	:vNewObj_xZkqqHx_iCmJjElKiCkEjAfGiClFiCkCiDiKiDjDiDeOiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iJpAjAoA_xHqqkZx_>	ToolChipPut_xZkqqHx_iCmMjDmGjHkHjFjEjFgJiDgAiDgCiDhGiCmJjBmOiJjOiClHiCoJiClNiCnPiBeBiClBiCmMiKnGjAjEiCpAjCmHiJmBiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	01.08.13 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolBasePutCreate::CreateRegisteredObject (	ObjDynabaseVector& vNewObj,
													DBLRect& mmrtFrame,
													FCLinkRecVector& vLinkRec) const
{
	vNewObj.clear();
	vLinkRec.clear();
	// _xZkqqHx_iDiKiDhEiDeAiDiMiDjDiDfIjFjEjFgJiCkJiCoHiNoMjAkMiClDiCoKiClNjFjEjFgJiBeC_xHqqkZx_
	FCObjDynabase* pNewObject = (FCObjDynabase*)m_pReference->Duplicate();
	mmrtFrame = pNewObject->GetResizeFrame();
	// _xZkqqHx_jFjEjFgJ_xHqqkZx_ID_xZkqqHx_iCpAiOoGjDlOiClFiBeBjFjEjFgJiCmJjAnNjCoIiClHiCoJiBeC_xHqqkZx_
	pNewObject->RegisterObjID();
	vNewObj.push_back(pNewObject);
} // FCToolBasePutCreate::CreateRegisteredObject .

//----- 06.12.09 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolBasePutCreate::OnDrawState
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iPjBiCkLjClMiClFiCmMiCmGiCkL_xHqqkZx_View_xZkqqHx_iCkJiCoHiOmAiNhDiClDiCoKiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC		:_xZkqqHx_jFfMiOkGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *			pmmrtRgn:_xZkqqHx_iDiKiBfLiDfHiDiHiDjDjEhKjHpBiCpAiOhHjCoIiBeCiOgHiCoNiCmIiCkCiPoKiNiHiCmN_xHqqkZx_NULL_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
 *			lRgnSize:pmmrtRgn_xZkqqHx_iCmMjEhKjHpBiDfEiDeDiDfJiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	00.01.25 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *			00.03.12 Fukushiro M. _xZkqqHx_iPiIjHjNiCpAjCmHiJmBiBeC_xHqqkZx_
 *************************************************************************/
void FCToolBasePutCreate::OnDrawState (CDC* pDC, int iState)
{
	// FDA_xZkqqHx_iCmMiMlLiNnNiCmMiPpDjBnEiBeC_xHqqkZx_
	switch (iState)
	{
	case STATE_PUTTING_TEXT:	// _xZkqqHx_iDgFiDeMiDfIiDgHjAnNjCoIjCiGiBeC_xHqqkZx_
	  {
		// _xZkqqHx_iDiKiDhEiDeAiDiMiDjDiDfIjFjEjFgJiCkKiCmIiCkCiCmIiCoHiCmOiBeBiPiIjHjNiClFiCmIiCkCiBeC_xHqqkZx_
		if (m_pReference == NULL) break;
		//----- _xZkqqHx_iDiKiDhEiDeAiDiMiDjDiDfIjFjEjFgJiCmMiDhEiDiMiBfLiDiAiCpAjFgAiJoG_xHqqkZx_ -----
		// _xZkqqHx_iPeDjAlDjApMjFgAiJoGjHhAiDeOiDiJiDfIiCpAiNoMjAkMiBeC_xHqqkZx_
		FCEditDraw eDraw(pDC, 0);
		// _xZkqqHx_iDhEiDiMiBfLiDiAjApMiCpAjFgAiJoGiBeC_xHqqkZx_
		eDraw.RectLine(mm2lg(m_mmptReferenceLT + m_mmptReferenceHSz),
						mm2lg(m_mmptReferenceHSz.x), mm2lg(m_mmptReferenceHSz.y));
		break;
	  }
	}
	// Superclass_xZkqqHx_iKnGjAjEiOmAiNhDiBeC_xHqqkZx_
	BASE_CLASS::OnDrawState(pDC, iState);
} // FCToolBasePutCreate::OnDrawState.
//----- 06.12.09 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolBasePutCreate::TransFDA
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iMiIjCoIjAkLjHeMiMmAiDeJiBfLiDgHiDhNiDgHiDjDiCmMjBeKiInKiCpAjFnEiClHiBeC_xHqqkZx_ToolBasePutCreate.mdrw_xZkqqHx_iCpAiOfBiPmGiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	iState	:_xZkqqHx_iMlLiNnNiCmMiPpDjBnEiCpAiOhHjCoIiBeC_xHqqkZx_
 *			iEvent	:_xZkqqHx_iDeDiDhIiDjDiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jFnEjCgM_xHqqkZx_>	_xZkqqHx_jBeKiInKiMoDiCmMiPpDjBnEiCpAjFnEiClHiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	00.01.25 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
int FCToolBasePutCreate::TransFDA (int iState, int iEvent)
{
	// _xZkqqHx_iInKiNhDjAoGiPpDjBnEiBeC_xHqqkZx_
	int iNextState = STATE_NONE;	// _xZkqqHx_iPpDjBnEjGlDiClFiBeC_xHqqkZx_

	// FDA_xZkqqHx_iCmMiMlLiNnNiCmMiPpDjBnEiBeC_xHqqkZx_
	switch (iState)
	{
	case STATE_IDLE:	// _xZkqqHx_jBnCiClPiBeC_xHqqkZx_
//----- 02.06.05 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ (_xZkqqHx_iDiMiDeDiDiEiBfLiCmMjFnCiPfHiMkAiCpAjBfDjFjEjGjFiPmB_xHqqkZx_->Undo->_xZkqqHx_jBlNiKhAjApMiDgDiBfLiDiLiCpAjBeJjBpA_xHqqkZx_->Redo->_xZkqqHx_jBlNiKhAjApMiCpAiNoMjAkMiClHiCoJiCmGjHiOiClPiCoJ_xHqqkZx_)-----
		if (FFCanCreateObject())
		//----- _xZkqqHx_jFjEjFgJiNoMjAkMiJmCjEfMiCmMiPoKiNiH_xHqqkZx_ -----
		{
//----- 02.06.05 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ (_xZkqqHx_iDiMiDeDiDiEiBfLiCmMjFnCiPfHiMkAiCpAjBfDjFjEjGjFiPmB_xHqqkZx_->Undo->_xZkqqHx_jBlNiKhAjApMiDgDiBfLiDiLiCpAjBeJjBpA_xHqqkZx_->Redo->_xZkqqHx_jBlNiKhAjApMiCpAiNoMjAkMiClHiCoJiCmGjHiOiClPiCoJ_xHqqkZx_)-----
			switch (iEvent)
			{
			case WM_LBUTTONDOWN:	// _xZkqqHx_iNlGiDhLiDfOiDjDiDfPiDeFiDjDiBeC_xHqqkZx_
			case WM_RBUTTONDOWN:	// _xZkqqHx_iJeFiDhLiDfOiDjDiDfPiDeFiDjDiBeC_xHqqkZx_
				if (!IsEditingText())
					iNextState = STATE_START_PUT_TEXT;	// _xZkqqHx_iDgFiDeMiDfIiDgHjAnNjCoIiKeKiOgOiBeC_xHqqkZx_
				break;
			}
// 02.06.06 Fukushiro M. 1_xZkqqHx_iNhDjCmHiJmB_xHqqkZx_ (_xZkqqHx_iDiMiDeDiDiEiBfLiCmMjFnCiPfHiMkAiCpAjBfDjFjEjGjFiPmB_xHqqkZx_->Undo->_xZkqqHx_jBlNiKhAjApMiDgDiBfLiDiLiCpAjBeJjBpA_xHqqkZx_->Redo->_xZkqqHx_jBlNiKhAjApMiCpAiNoMjAkMiClHiCoJiCmGjHiOiClPiCoJ_xHqqkZx_)
		}
		break;
	case STATE_START_PUT_TEXT:	// _xZkqqHx_iDgFiDeMiDfIiDgHjAnNjCoIiKeKiOgOiBeC_xHqqkZx_
		iNextState = STATE_PUTTING_TEXT;	// _xZkqqHx_iDgFiDeMiDfIiDgHjAnNjCoIjCiGiBeC_xHqqkZx_
		break;
	case STATE_PUTTING_TEXT:	// _xZkqqHx_iDgFiDeMiDfIiDgHjAnNjCoIjCiGiBeC_xHqqkZx_
		switch (iEvent)
		{
		case WM_MOUSEMOVE:	// _xZkqqHx_iDhNiDeFiDfIiInKjDkOiBeC_xHqqkZx_
			iNextState = STATE_PUTTING_TEXT;	// _xZkqqHx_iDgFiDeMiDfIiDgHjAnNjCoIjCiGiBeC_xHqqkZx_
			break;
		case WM_LBUTTONUP:	// _xZkqqHx_iNlGiDhLiDfOiDjDiDeBiDgCiDhGiBeC_xHqqkZx_
			iNextState = STATE_STOP_PUT_TEXT;	// _xZkqqHx_iDgFiDeMiDfIiDgHjAnNjCoIiPeJjHlJiBeC_xHqqkZx_
			break;
		case WM_RBUTTONUP:	// _xZkqqHx_iJeFiDhLiDfOiDjDiDeBiDgCiDhGiBeC_xHqqkZx_
			if (m_pHitMolipObj != NULL)
				iNextState = STATE_STOP_PUT_TEXT_2;	// _xZkqqHx_iDgFiDeMiDfIiDgHjAnNjCoIiPeJjHlJ_xHqqkZx__2_xZkqqHx_iBeC_xHqqkZx_
			else
				iNextState = STATE_STOP_PUT_TEXT;	// _xZkqqHx_iDgFiDeMiDfIiDgHjAnNjCoIiPeJjHlJiBeC_xHqqkZx_
			break;
		}
		break;
	case STATE_STOP_PUT_TEXT:	// _xZkqqHx_iDgFiDeMiDfIiDgHjAnNjCoIiPeJjHlJiBeC_xHqqkZx_
		iNextState = STATE_DO_PUT_TEXT;		// _xZkqqHx_iDgFiDeMiDfIiDgHjAnNjCoIiBeC_xHqqkZx_
		break;
	case STATE_DO_PUT_TEXT:		// _xZkqqHx_iDgFiDeMiDfIiDgHjAnNjCoIiBeC_xHqqkZx_
		iNextState = STATE_IDLE;	// _xZkqqHx_jBnCiClPiBeC_xHqqkZx_
		break;
	case STATE_STOP_PUT_TEXT_2:		// _xZkqqHx_iDgFiDeMiDfIiDgHjAnNjCoIiPeJjHlJ_xHqqkZx__2_xZkqqHx_iBeC_xHqqkZx_
		switch (iEvent)
		{
		case WM_CONTEXTMENU:	// _xZkqqHx_iDfCiDjDiDgFiDeMiDfIiDgHiDiBiDgKiDiFiBfLiBeC_xHqqkZx_
			iNextState = STATE_CONTEXT_MENU_LINK_2;	// _xZkqqHx_iDiBiDgKiDiFiBfLjFfMiOkG_xHqqkZx___xZkqqHx_iDiKiDjDiDeO_xHqqkZx__2_xZkqqHx_iBeC_xHqqkZx_
			break;
		}
		break;
	case STATE_CONTEXT_MENU_LINK_2:	// _xZkqqHx_iDiBiDgKiDiFiBfLjFfMiOkG_xHqqkZx___xZkqqHx_iDiKiDjDiDeO_xHqqkZx__2_xZkqqHx_iBeC_xHqqkZx_
		switch (iEvent)
		{
		case WM_COMMAND:	// _xZkqqHx_iDfCiDhNiDjDiDgIiBeC_xHqqkZx_
			iNextState = STATE_LINK_COMMAND_PUT;	// _xZkqqHx_iDiKiDjDiDeOiDfCiDhNiDjDiDgI_xHqqkZx___xZkqqHx_jEhKjChFiBeC_xHqqkZx_
			break;
		}
		break;
	case STATE_LINK_COMMAND_PUT:	// _xZkqqHx_iDiKiDjDiDeOiDfCiDhNiDjDiDgI_xHqqkZx___xZkqqHx_jEhKjChFiBeC_xHqqkZx_
		iNextState = STATE_DO_PUT_TEXT;		// _xZkqqHx_iDgFiDeMiDfIiDgHjAnNjCoIiBeC_xHqqkZx_
		break;
	}
	// _xZkqqHx_iPpDjBnEjBeKiInKjGlDiClFiCmMiPoKiNiHiCmNiDfIiBfLiDhAiBfLiDeOiDiJiDfIiCmMiPpDjBnEjBeKiInKiCpAiMmEiCnBiPgPiClHiBeC_xHqqkZx_
	if (iNextState == STATE_NONE)
		iNextState = BASE_CLASS::TransFDA(iState, iEvent);
	return iNextState;
} // FCToolBasePutCreate::TransFDA.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolBasePutCreate::StateFDA
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iPpDjBnEiCmJiJjOiClGiClNiPiIjHjNiCpAiOmAiNhDiClHiCoJiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	iState	:_xZkqqHx_iMlLiNnNiCmMiPpDjBnEiCpAiOhHjCoIiBeC_xHqqkZx_
 *			pDC		:_xZkqqHx_jFgAiJoGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	00.01.25 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolBasePutCreate::StateFDA (int iState, CDC* pDC)
{
	// FDA_xZkqqHx_iCmMiOjPiCmMiPpDjBnEiBeC_xHqqkZx_
	switch (iState)
	{
	case STATE_START_PUT_TEXT:	// _xZkqqHx_iDgFiDeMiDfIiDgHjAnNjCoIiKeKiOgOiBeC_xHqqkZx_
		StateStartPutText(pDC);
		break;
	case STATE_PUTTING_TEXT:	// _xZkqqHx_iDgFiDeMiDfIiDgHjAnNjCoIjCiGiBeC_xHqqkZx_
		StatePuttingText(pDC);
		break;
	case STATE_STOP_PUT_TEXT:	// _xZkqqHx_iDgFiDeMiDfIiDgHjAnNjCoIiPeJjHlJiBeC_xHqqkZx_
		StateStopPutText(pDC);
		break;
	case STATE_DO_PUT_TEXT:		// _xZkqqHx_iDgFiDeMiDfIiDgHjAnNjCoIiBeC_xHqqkZx_
		StateDoPutText(pDC);
		break;
	case STATE_STOP_PUT_TEXT_2:		// _xZkqqHx_iDgFiDeMiDfIiDgHjAnNjCoIiPeJjHlJ_xHqqkZx__2_xZkqqHx_iBeC_xHqqkZx_
		StateStopPutText(pDC);
		break;
	case STATE_CONTEXT_MENU_LINK_2:	// _xZkqqHx_iDiBiDgKiDiFiBfLjFfMiOkG_xHqqkZx___xZkqqHx_iDiKiDjDiDeO_xHqqkZx__2_xZkqqHx_iBeC_xHqqkZx_
		StateContextMenuLink(pDC);
		break;
	case STATE_LINK_COMMAND_PUT:	// _xZkqqHx_iDiKiDjDiDeOiDfCiDhNiDjDiDgI_xHqqkZx___xZkqqHx_jEhKjChFiBeC_xHqqkZx_
		StateLinkCommandPut(pDC);
		break;
	default:
		BASE_CLASS::StateFDA(iState, pDC);
	}
} // FCToolBasePutCreate::StateFDA.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolBasePutCreate::StateIdle
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_jBnCiClPiPiIjHjNiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	:_xZkqqHx_jFgAiJoGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	00.01.25 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolBasePutCreate::StateIdle (CDC* pDC)
{
//	TRACE(_T("StateIdle\r\n"));
	if (!IsControl())
	{
		DBLPoint mmptHitPos;
		m_pHitMolipObj = NULL;		// _xZkqqHx_iDiKiDjDiDeOjFjEjFgJiBeC_xHqqkZx_
		m_lHitMolip = -1;			// _xZkqqHx_iDiKiDjDiDeOiDiCiDiKiDhGiBeC_xHqqkZx_
		// _xZkqqHx_iDiCiDiKiDhGiMjPiNpFiBeCjAfGiClFiCkCiDeKiBfLiDfMiDiLiCpAjAnNjCoIiBeC_xHqqkZx_
		m_iCursorNew = FCLinkManager::GetHitOnMolip(m_pHitMolipObj,
													m_lHitMolip,
													mmptHitPos,
													m_mmptMsc,
													NULL,
//----- 05.06.16 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//													5,
//													50,
//----- 05.06.16 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----
													TRUE);
		// _xZkqqHx_iDiCiDiKiDhGiPoDiDhBiDgCiDgHiCmMiPoKiNiHiCmNiBeBiDhNiDeFiDfIiNmAjFfHiCpAiDiCiDiKiDhGiNmAjFfHiCmJjFoCjAlDiBeC_xHqqkZx_
		if (m_iCursorNew != FDPA_HIT_NOT_MOLIP) m_mmptCnv = mmptHitPos;
	} else
	{
		m_iCursorNew = FDPA_HIT_NOT_MOLIP;
		m_pHitMolipObj = NULL;
	}
	// Superclass_xZkqqHx_iKnGjAjEiBeCiDeKiBfLiDfMiDiLiCpAjFfMiOkGiBeC_xHqqkZx_
	BASE_CLASS::StateIdle(pDC);
} // FCToolBasePutCreate::StateIdle.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolBasePutCreate::StateStartPutText
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDgFiDeMiDfIiDgHjAnNjCoIiKeKiOgOiPiIjHjNiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	:_xZkqqHx_jFgAiJoGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	00.01.25 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolBasePutCreate::StateStartPutText (CDC* pDC)
{
	TRACE(_T("StateStartPutText\r\n"));
	//----- _xZkqqHx_iDiKiDjDiDeOiCmMiOoNjHnOiCpAiMiIjCoI_xHqqkZx_ -----
	if (m_pHitMolipObj != NULL)
	{
		if (m_lHitMolip == -1)
			// mmptOffset_xZkqqHx_iCmNiBeBiDiCiDiKiDhGiCkJiCoHiCmMiDfEiDeDiDfJjEoEjHkGjCgMiBeC_xHqqkZx_
			m_dwPutLinkKind = FDLM_LINK_ON_RATIO;
		else
			// mmptOffset_xZkqqHx_iCmNiBeBiDiCiDiKiDhGiCkJiCoHiCmMjBiKjBmOiNmAjFfHjCgMiBeC_xHqqkZx_
			m_dwPutLinkKind = FDLM_LINK_ON_COORD;
	} else
	{
		m_dwPutLinkKind = DWORD(0);
	}
	// OnLButtonUp_xZkqqHx_iCnMiCmFiClBiCmM_xHqqkZx_Window_xZkqqHx_iCmJiDeDiDhIiDjDiDgHiBeC_xHqqkZx_
	::FFSetCapture(g_pView->m_hWnd);
	// MsMove_xZkqqHx_iCpAiMgPiClIiBeBiCkCiCkLiCmIiCoI_xHqqkZx_LBtnDown_xZkqqHx_iCmJjBmOiJjOiBeC_xHqqkZx_FCToolBase::OnObjectPutRtfObj_xZkqqHx_iCkJiCoHiBeCiBeC_xHqqkZx_
	StateIdle(pDC);
do {
	// _xZkqqHx_iDiKiDhEiDeAiDiMiDjDiDfIjFjEjFgJiOoGjDlOiBeC_xHqqkZx_
	m_pReference = GetReferenceObject();
	// _xZkqqHx_iDiKiDhEiDeAiDiMiDjDiDfIjFjEjFgJiCkKiCmIiCkCiCmIiCoHiCmOiBeBiPiIjHjNiClFiCmIiCkCiBeC_xHqqkZx_
	if (m_pReference == NULL) break;
	// _xZkqqHx_iDiKiDhEiDeAiDiMiDjDiDfIjFjEjFgJiCmMiDhEiDiMiBfLiDiAiCpAiOoGjDlOiBeC_xHqqkZx_
	DBLRect mmrtTemplate = m_pReference->GetResizeFrame();
	// _xZkqqHx_iDiKiDhEiDeAiDiMiDjDiDfIjFjEjFgJiDhEiDiMiBfLiDiAiCmMiDfEiDeDiDfJ_xHqqkZx_/2_xZkqqHx_iBeC_xHqqkZx_
	m_mmptReferenceHSz.SetPoint(mmrtTemplate.Width() / 2.0,
								mmrtTemplate.Height() / 2.0);
	// _xZkqqHx_iDiKiDhEiDeAiDiMiDjDiDfIjFjEjFgJiDhEiDiMiBfLiDiAiCmMiNlGiPoDiBeC_xHqqkZx_
	m_mmptReferenceLT = m_mmptMsc - m_mmptReferenceHSz;
	FFSnapMP(m_mmptReferenceLT);
	// _xZkqqHx_iPeDjAlDjApMjFgAiJoGjHhAiDeOiDiJiDfIiCpAiNoMjAkMiBeC_xHqqkZx_
	FCEditDraw eDraw(pDC, 0);
	eDraw.RectLine(mm2lg(m_mmptReferenceLT + m_mmptReferenceHSz),
					mm2lg(m_mmptReferenceHSz.x), mm2lg(m_mmptReferenceHSz.y));
	// _xZkqqHx_iOkJjDkOiDfIiDeOiDiNiBfLiDiLiBgJiJoGjGmKiCpAiCmNiCnNiPgPiClFiClNiOjOiBgKiCpAiCgOiCgNiBeC_xHqqkZx_
	g_pView->SetAutoScroll(TRUE);
} while (FALSE);
} // FCToolBasePutCreate::StateStartPutText.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolBasePutCreate::StatePuttingText
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDgFiDeMiDfIiDgHjAnNjCoIjCiGiPiIjHjNiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	:_xZkqqHx_jFgAiJoGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	00.01.25 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolBasePutCreate::StatePuttingText (CDC* pDC)
{
	TRACE(_T("StatePuttingText\r\n"));
do {
	// _xZkqqHx_iDiKiDhEiDeAiDiMiDjDiDfIjFjEjFgJiCkKiCmIiCkCiCmIiCoHiCmOiBeBiPiIjHjNiClFiCmIiCkCiBeC_xHqqkZx_
	if (m_pReference == NULL) break;
	//----- _xZkqqHx_iDiKiDhEiDeAiDiMiDjDiDfIjFjEjFgJiCmMiDhEiDiMiBfLiDiAiCpAjFgAiJoG_xHqqkZx_ -----
	// _xZkqqHx_iPeDjAlDjApMjFgAiJoGjHhAiDeOiDiJiDfIiCpAiNoMjAkMiBeC_xHqqkZx_
	FCEditDraw eDraw(pDC, 0);
	// _xZkqqHx_jBePiJpBiCmMjApMiCpAiPmBiLiOiBeC_xHqqkZx_
	eDraw.RectLine(mm2lg(m_mmptReferenceLT + m_mmptReferenceHSz),
					mm2lg(m_mmptReferenceHSz.x), mm2lg(m_mmptReferenceHSz.y));
	// _xZkqqHx_iDiKiDhEiDeAiDiMiDjDiDfIjFjEjFgJiDhEiDiMiBfLiDiAiCmMiNlGiPoDiBeC_xHqqkZx_
	m_mmptReferenceLT = m_mmptMsc - m_mmptReferenceHSz;
	FFSnapMP(m_mmptReferenceLT);
	// _xZkqqHx_jAfGiClFiCkCjApMiCpAjFgAiJoGiBeC_xHqqkZx_
	eDraw.RectLine(mm2lg(m_mmptReferenceLT + m_mmptReferenceHSz),
					mm2lg(m_mmptReferenceHSz.x), mm2lg(m_mmptReferenceHSz.y));
} while (FALSE);
} // FCToolBasePutCreate::StatePuttingText.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolBasePutCreate::StateStopPutText
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDgFiDeMiDfIiDgHjAnNjCoIiPeJjHlJiPiIjHjNiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	:_xZkqqHx_jFgAiJoGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	01.04.28 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolBasePutCreate::StateStopPutText (CDC* pDC)
{
	TRACE(_T("StateStopPutText\r\n"));
	// _xZkqqHx_iOkJjDkOiDfIiDeOiDiNiBfLiDiLiBgJiJoGjGmKiCpAiCmNiCnNiPgPiClFiClNiOjOiBgKiCpAiDeJiDhEiBeC_xHqqkZx_
	g_pView->SetAutoScroll(FALSE);
	::FFReleaseCapture();	// _xZkqqHx_iDhNiDeFiDfIiCmMiDgIiDiJiDgCiDePiCmMiKeKiOgOiCmJiCoGiCmBiCmEiOgOiCnMiCmBiClNiDhNiDeFiDfIiCmM_xHqqkZx_
							// _xZkqqHx_jFnPiKgMiCpAiJpAiPjMiClFiCnMiClHiBeC_xHqqkZx_
} // FCToolBasePutCreate::StateStopPutText.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolBasePutCreate::StateDoPutText
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDgFiDeMiDfIiDgHjAnNjCoIiPiIjHjNiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	:_xZkqqHx_jFgAiJoGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	00.01.25 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolBasePutCreate::StateDoPutText (CDC* pDC)
{
	TRACE(_T("StateDoPutText\r\n"));
	// _xZkqqHx_iDiKiDhEiDeAiDiMiDjDiDfIjFjEjFgJiCkKiCmIiCkCiCmIiCoHiCmOiBeBiPiIjHjNiClFiCmIiCkCiBeC_xHqqkZx_
	if (m_pReference == NULL)
	{
		// _xZkqqHx_iDiKiDhEiDeAiDiMiDjDiDfIjFjEjFgJiCkJiCoHiNoMjAkMiClDiCoKiClNjFjEjFgJiBeC_xHqqkZx_
		// _xZkqqHx_iDgDiBfLiDiLiDfKiDgCiDfGiDiHiDjDiPeJjHlJiBeC_xHqqkZx_
		EndOfSession();
	} else
	{
		// _xZkqqHx_iDeLiDeDiDgIiDhNiBfLiDeOiCpAiPmBiLiOiBeC_xHqqkZx_
		DrawMark(pDC, TRUE);
		// _xZkqqHx_jAfGiClFiCkCiDeKiBfLiDfMiDiLiCmJiBgIjGlDiMpIiBgIiCpAjAnNjCoIiBeCiClBiCoKiCmFiDeLiDeDiDgIiDeKiBfLiDfMiDiLiCmNjFgAiJoGiClDiCoKiCmIiCkCiBeC_xHqqkZx_
		m_iCursorNew = FDPA_HIT_NONE;
		// _xZkqqHx_iPeDjAlDjApMjFgAiJoGjHhAiDeOiDiJiDfIiCpAiNoMjAkMiBeC_xHqqkZx_
		FCEditDraw eDraw(pDC, 0);
		// _xZkqqHx_jBePiJpBiCmMjApMiCpAiPmBiLiOiBeC_xHqqkZx_
		eDraw.RectLine(mm2lg(m_mmptReferenceLT + m_mmptReferenceHSz),
						mm2lg(m_mmptReferenceHSz.x), mm2lg(m_mmptReferenceHSz.y));

		// _xZkqqHx_iLeMjIfOiDfKiDgCiDfGiDiHiDjDiKeKiOgOiBeCiNmFiPiJiCmMiDfKiDgCiDfGiDiHiDjDiOjOiCmN_xHqqkZx_Undo_xZkqqHx_iDhEiDeAiDeDiDiLiCpA_xHqqkZx_Open_xZkqqHx_iClHiCoJiCmMiCmFiBeB_xHqqkZx_
		// CreateRegisteredObject_xZkqqHx_iKnGjAjEiCmMjBePiCmJiCmIiCkPiCoKiCmOiCmIiCoHiCmIiCkCiBeC_xHqqkZx_
		g_pDoc->SessionBegin();
		// _xZkqqHx_iDiKiDhEiDeAiDiMiDjDiDfIjFjEjFgJiCkJiCoHiNoMjAkMiClDiCoKiClNjFjEjFgJiBeC_xHqqkZx_
		ObjDynabaseVector vNewObject;
		DBLRect mmrtFrame;
		FCLinkRecVector vLinkRec;
		CreateRegisteredObject(vNewObject, mmrtFrame, vLinkRec);
		DBLPoint mmptMove = m_mmptReferenceLT - DBLPoint(mmrtFrame.left, mmrtFrame.top);
		// _xZkqqHx_jAfGiLeLjFjEjFgJiCpAiInKjDkOiBeC_xHqqkZx_
		ObjDynabaseVector::const_iterator iObj;
		for (iObj = vNewObject.begin(); iObj != vNewObject.end(); iObj++)
			(*iObj)->Move(mmptMove.x, mmptMove.y);
		// _xZkqqHx_jFjEjFgJjAlGjAkMiCmMiLeMjIfOiBeC_xHqqkZx_
		for (iObj = vNewObject.begin(); iObj != vNewObject.end(); iObj++)
			g_pDoc->MulticmdCreate1Obj(*iObj, g_pDoc->GetCurrentSheetId(), LAST_LAYER_ORDER);
		if (m_pHitMolipObj != NULL)
		{
			for (iObj = vNewObject.begin(); iObj != vNewObject.end(); iObj++)
			{
				//----- _xZkqqHx_iDiKiDjDiDeOiNoMjAkM_xHqqkZx_ -----
				FCMolipRec linkFrom(m_pHitMolipObj->GetObjID(), m_lHitMolip);
				FCMolipRec linkTo((*iObj)->GetObjID(), -1);
				WORD wLinkKindA = m_dwPutLinkKind & 0xffff;
				WORD wLinkKindB = m_dwPutLinkKind >> 16;
				if (wLinkKindA != WORD(0))
					vLinkRec.push_back(FCLinkRec(linkFrom, linkTo, DBLPoint(), wLinkKindA));
				if (wLinkKindB != WORD(0))
					vLinkRec.push_back(FCLinkRec(linkTo, linkFrom, DBLPoint(), wLinkKindB));
			}
		}
//----- 05.05.08 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
		// _xZkqqHx_iNmEjFgAiJoGiCkKjFeLjHhGiCmIjFjEjFgJiBeC_xHqqkZx_
		ObjDynabaseSet stRedrawObj;
//----- 05.05.08 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----
		// _xZkqqHx_iDiKiDjDiDeOjAlGjAkMiBeC_xHqqkZx_
		FCLinkRecVector::const_iterator iLr;
		for (iLr = vLinkRec.begin(); iLr != vLinkRec.end(); iLr++)
		{
			g_pDoc->CmdAppend1Link(stRedrawObj, (*iLr).m_mlpFrom, (*iLr).m_mlpTo, (*iLr).m_wLinkKind);
		}
//----- 05.05.08 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
		// _xZkqqHx_iNmEjFgAiJoGjFjEjFgJiCpAjAnNjCoIiBeC_xHqqkZx_
		g_pView->AppendToLastRgn(stRedrawObj);
//----- 05.05.08 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----
		// _xZkqqHx_iLeMjIfOiDfKiDgCiDfGiDiHiDjDiCmMiPeJjHlJiBeC_xHqqkZx_
		g_pDoc->SessionEnd();
		// _xZkqqHx_jBeJjBpAjCiGiCmMjFjEjFgJiCpAiJpAiPjMiBeC_xHqqkZx_
		g_pView->ClearSelectObj(pDC);
		// _xZkqqHx_jAfGiClFiCkCjFjEjFgJiCpAjBeJjBpAiPpDjBnEiCmJiBeC_xHqqkZx_
		g_pView->AppendSelectObj(vNewObject);
		// _xZkqqHx_jFjEjFgJiCpAjFgAiJoGiClHiCoJiBeC_xHqqkZx_
		g_pView->AppendToLastRgn(vNewObject);
		g_pView->SendRgnRedraw();
		// _xZkqqHx_iNmFiMoDiCmJiNoMjAkMiClDiCoKiClNjFjEjFgJiCmGiClFiCmEjDgPjIfOiBeC_xHqqkZx_
		SetLastCreateObj(vNewObject.back());
//----- 06.04.08 Fukushiro M. _xZkqqHx_jCmHiJmBiOgO_xHqqkZx_ ()-----
		// _xZkqqHx_jCfAjDmGiCmMiDiJiDhIiDiLjFjEjFgJiCmMiPoKiNiHiBeBiClHiCkOjFnCiPfHiPiIjHjNiCmJjDpMiCoJiBeC_xHqqkZx_
		// DDPro_xZkqqHx_iCmFiOgHiCkEiPoKiNiHiBeBiDiJiDhIiDiLjFjEjFgJiCmNjFkBiOmKiClFiCmEjFpKjChFiClHiCoJiCmG_xHqqkZx_
		// _xZkqqHx_iDiJiDhIiDiLiCkKjFmPiNfIiClDiCoKiCmIiCkCiCnMiCnMiBeBjHjKjHpAiNfMjBkCiDhCiDiFiBfLiCmJiPgPiCmEiClFiCnMiCkEiBeC_xHqqkZx_
		// _xZkqqHx_iClHiCkOjFmPiNfIiClHiCoKiCmOiBeBjAfGiClFiCkCjDoAjHgFiCmFjFfMiOkGiClDiCoKiCoJiBeC_xHqqkZx_
		if (vNewObject.size() == 1 &&
			vNewObject.front()->IsKindOf(FDOJ_LABEL))
		{
			// _xZkqqHx_iOjPiCmMiDgDiBfLiDiLiCmJiDgFiDeMiDfIiDgHjFnCiPfHiDgDiBfLiDiLiCpAiOhHjCoIiBeC_xHqqkZx_
			SetNextTool(ID_TOOL_EDIT_RICH_TEXT);
			// _xZkqqHx_iDiNiDgCiDeOiCpAiJpAiPjMiClFiCmEiCkIiCkNiBeC_xHqqkZx_
			SetLockStatus(FALSE);
		}
//----- 06.04.08 Fukushiro M. _xZkqqHx_jCmHiJmBiPeJ_xHqqkZx_ ()-----
	}
} // FCToolBasePutCreate::StateDoPutText.

/*************************************************************************
 * <_xZkqqHx_iKnGjAjE_xHqqkZx_>	FCToolBasePutCreate::StateLinkCommandPut
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_iDiKiDjDiDeOiDfCiDhNiDjDiDgI_xHqqkZx___xZkqqHx_jEhKjChFiBeC_xHqqkZx_
 *
 * <_xZkqqHx_iIpIjAjE_xHqqkZx_>	pDC	:_xZkqqHx_jFgAiJoGjHhAiDgGiDgPiDeDiDfIiDfCiDjDiDgFiDeMiDfIiDgHiCpAiOhHjCoIiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	01.04.28 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
void FCToolBasePutCreate::StateLinkCommandPut (CDC* pDC)
{
	TRACE(_T("StateLinkCommandPut\r\n"));
	m_dwPutLinkKind = CommandToLinkKind(m_dwCommand, m_lHitMolip == -1);
} // FCToolBasePutCreate::StateLinkCommandPut.


